<?php

class ExecScript
{
    /**
     * 安装脚本
     */
    public function install(){
        //判断当前版本
        $versionData=app("L_Common_version")->currentInfo();
        if($versionData["project"]=="lt_cms" && $versionData["stage"]=="alpha" && $versionData["version"]=="1.0.1"){
            $this->resetCache();
        }else if($versionData["project"]=="lt_cms" && $versionData["stage"]=="alpha" && $versionData["version"]=="1.0.2"){
            $this->upAdminFunc();
        }else if($versionData["project"]=="lt_cms" && $versionData["stage"]=="release" && $versionData["version"]=="1.0.4"){
            $this->resetCache();
            $this->upAdminFunc();

//            $paramsObj=paramsObj();
//            $paramsObj->params=array(
//                'op' => 'random',
//                'pid' => '4',
//            );
//            $setting=new \app\logic\api\L_setting($paramsObj);
//            $setting->store($paramsObj);
        }
        return true;
    }

    /**
     * 更新路由信息
     */
    public function upAdminFunc(){
        //去除前缀
        $pre=app("cmsTable")->getPre();
        $sql="UPDATE {$pre}member_admin_func SET route = REPLACE(route, 'admin/', '') where `plugins` =''";
        $sql2="UPDATE {$pre}member_admin_func SET route = REPLACE(route, '/category?', 'category?') where `plugins` ='' and `module`='admin/Category'";
        Db()->execute($sql);
        Db()->execute($sql2);
    }

    /**
     * 重置缓存
     */
    public function resetCache(){
        //更新数据库字段
        $category=runtimePath("cache/category");
        $module=runtimePath("cache/module");
        $setting=runtimePath("cache/setting");

        if(is_dir($category)){
            dirDelete($category);
        }
        if(is_dir($module)){
            dirDelete($module);
        }
        if(is_dir($setting)){
            dirDelete($setting);
        }
    }
}